Index: trunk/src/ProcessManagement/ProcessManagement/Forms/DataEntry/ApprovalPerson/FrmApprovalPersonAuxiliary.cs
===================================================================
--- trunk/src/ProcessManagement/ProcessManagement/Forms/DataEntry/ApprovalPerson/FrmApprovalPersonAuxiliary.cs	(nonexistent)
+++ trunk/src/ProcessManagement/ProcessManagement/Forms/DataEntry/ApprovalPerson/FrmApprovalPersonAuxiliary.cs	(revision 52)
@@ -0,0 +1,1107 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Data;
+using System.Drawing;
+using System.Text;
+using System.Windows.Forms;
+using System.Collections;
+using System.Linq;
+using System.Diagnostics;
+using System.Data.Common;
+
+using log4net;
+using log4net.Appender;
+using log4net.Repository.Hierarchy;
+
+using ProcessManagement.Common;
+using ProcessManagement.DB.IOAccess;
+using ProcessManagement.DataModel;
+using ProcessManagement.DB.Core;
+using ProcessManagement.Forms.Master;
+using ProcessManagement.Forms.SubForms;
+using ProcessManagement.Forms.ControlsAction;
+using ProcessManagement.Forms.CustomControls;
+
+namespace ProcessManagement.Forms.DataEntry
+{
+    partial class FrmApprovalPerson
+    {
+
+        #region ひとつ前のプロセスを確認する
+        /// <summary>
+        /// ひとつ前のプロセスを確認する
+        /// </summary>
+        /// <returns></returns>
+        private bool PrevProcessCheck()
+        {
+            bool bAns = false;
+
+            int NowPoint = ClsExcute.GetNowProcessPoint();
+            if (NowPoint < 1) return bAns;
+
+            ProcessParameter RecPara = ClsExcute.ProcControlPara[NowPoint - 1];
+
+            // 承認起動画面からの起動はボタン表示しない
+            // 承認対象コードを取得する
+            switch (m_ApprovalCode)
+            {
+                // 1:積算見積書入力
+                case (int)ClsExcute.ApprovalListNo.EstimateApproval:
+                    if (RecPara.ProcNo == (int)ClsExcute.ProcessExecuteNo.EstimateInput) bAns = true;
+                    break;
+                // 2:積算予算書入力
+                case (int)ClsExcute.ApprovalListNo.EstimateBudgetApproval:
+                    if (RecPara.ProcNo == (int)ClsExcute.ProcessExecuteNo.EstimateBudget) bAns = true;
+                    break;
+                // 3:工事予算書入力
+                case (int)ClsExcute.ApprovalListNo.ConstructionBudgetApproval:
+                    if (RecPara.ProcNo == (int)ClsExcute.ProcessExecuteNo.ConstructionBudget) bAns = true;
+                    break;
+                // 4:注文書承認
+                case (int)ClsExcute.ApprovalListNo.PurchaseOrderEntryApproval:
+                    if (RecPara.ProcNo == (int)ClsExcute.ProcessExecuteNo.PurchaseOrderEntry) bAns = true;
+                    break;
+                // 5:請求書承認
+                case (int)ClsExcute.ApprovalListNo.OrderBillingApproval:
+                    //if (RecPara.ProcNo == (int)ClsExcute.ProcessExecuteNo.ConstructionBudget) bAns = true;
+                    break;
+                // 6:工事日報承認
+                case (int)ClsExcute.ApprovalListNo.DRConstructionApproval:
+                    if (RecPara.ProcNo == (int)ClsExcute.ProcessExecuteNo.DRConstruction) bAns = true;
+                    break;
+            }
+
+            return bAns;
+        }
+        #endregion
+
+        #region 対象データ確認ボタン表示
+        /// <summary>
+        /// 対象データ確認ボタンの表示制御
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void DispbtnTargetData()
+        {
+            // 承認起動画面からの起動はボタン表示しない
+            //if (PrevProcessCheck()) btnTargetData.Visible = false;
+            if (ClsApprovalPermission.ExceApprovalScreen((int)ClsExcute.SubFormExecuteNo.ApprovalPerson))
+                btnTargetData.Visible = false;
+        }
+        #endregion
+
+        #region 承認時データ更新処理
+        /// <summary>
+        /// 承認時にデータを更新する
+        /// </summary>
+        /// <param name="Rec"></param>
+        /// <returns></returns>
+        private bool DataUpdate(PersonApproval Rec)
+        {
+            try
+            {
+                if (!ClsApprovalPermission.CreatePetitionApproval(Rec))
+                {
+                    MessageBox.Show("承認申請に失敗しました。", "申請エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return false;
+                }
+
+                // 申請者と最初の承認者が同じ場合は申請時に承認する
+                if (m_dispLabelControl[(int)DispHeader.PetitionName].Text.Equals(m_dispLabelControl[(int)DispHeader.ApprovalName].Text))
+                {
+                    // 申請・承認レコード更新
+                    if (!ApprovalDataUpDate((int)CommonDefine.ApprovalStatus.Approval))
+                    {
+                        MessageBox.Show("承認に失敗しました。", "承認エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return false;
+                    }
+                }
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 申請・承認レコードの更新
+        /// <summary>
+        /// 申請・承認レコードの更新
+        /// </summary>
+        /// <param name="statusCode"></param>
+        /// <returns></returns>
+        public bool ApprovalDataUpDate(int statusCode, bool bInSideFlg = true)
+        {
+            try
+            {
+                // 工事情報取得
+                if (!SetBaseInfoData()) return false;
+
+                PersonApproval Rec = new PersonApproval();
+
+                // 承認レコードの作成
+                CreateApprovalData(ref Rec, statusCode);
+
+                // 承認レコード更新
+                if (!ClsApprovalPermission.CreatePetitionApproval(Rec)) return false;
+
+                // 申請レコード更新
+                // 承認時は条件を満たすかをチェックする
+                switch (statusCode)
+                {
+                    case (int)CommonDefine.ApprovalStatus.Approval:
+                        // ----- 承認
+                        // 案件に対して最終承認がされているかを確認する
+                        if (ClsApprovalPermission.CheckPersonApprovalData(m_PersonCode, m_ApprovalCode, m_OrderDate))
+                        {
+                            // 最終承認がされていれば申請レコードを承認へ変更する
+                            ClsApprovalPermission.SetPrimaryRecStatus(m_PersonCode, m_ApprovalCode, m_OrderDate, (int)CommonDefine.ApprovalStatus.Approval);
+                        }
+                        break;
+                    case (int)CommonDefine.ApprovalStatus.NotApproval:
+                        // ----- 非承認
+                        ClsApprovalPermission.SetPrimaryRecStatus(m_PersonCode, m_ApprovalCode, m_OrderDate, (int)CommonDefine.ApprovalStatus.NotApproval);
+                        break;
+                }
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 承認レコードデータ作成
+        /// <summary>
+        /// 承認レコードデータ作成
+        /// </summary>
+        /// <param name="Rec"></param>
+        /// <param name="Status"></param>
+        private void CreateApprovalData(ref PersonApproval Rec, int Status)
+        {
+            IOPersonApproval ApprDB = new IOPersonApproval();
+            try
+            {
+                // 申請レコード以外で自分の承認レコードがあるかをチェックする
+                string strSQL = ApprDB.CreatePrimarykeyString(m_PersonCode, m_ApprovalCode, m_OrderDate);
+                strSQL += " And SeqNo != 1";
+                strSQL += string.Format(" AND PersonCode = {0}", CommonMotions.LoginUserData.PersonCode);
+                if (!ApprDB.SelectAction(strSQL, ref Rec))
+                {
+                    Rec.PersonCode = m_PersonCode;                                  // 担当者番号
+                    Rec.ApprovalCode = m_ApprovalCode;	                            // 承認機能番号
+                    Rec.OrderDate = m_OrderDate;	                                // 受付日
+                    Rec.PersonCode = CommonMotions.LoginUserData.PersonCode;        // 申請・承認者コード
+                    Rec.PetitionApprovalDate = DateTime.Now;	                    // 承認日付
+
+                    strSQL = ApprDB.CreatePrimarykeyString(m_PersonCode, m_ApprovalCode, m_OrderDate);
+                    Rec.SeqNo = ApprDB.SelectMaxSeqNoCount(strSQL) + 1;             // 枝番
+                }
+                // 承認状態をセットする
+                Rec.ApprovalStatus = Status;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                ApprDB.close(); ApprDB = null;
+            }
+        }
+        #endregion
+
+        #region 表示オブジェクトの取得
+        /// <summary>
+        /// 表示オブジェクトの取得
+        /// </summary>
+        private void SetDisplayObject()
+        {
+            // 表示オブジェクト領域確保
+            int CtrlCnt = Enum.GetNames(typeof(DispHeader)).Length;
+            m_dispLabelControl = new Control[CtrlCnt];
+            
+            m_dispLabelControl[(int)DispHeader.PersonName] = lblLabel03;
+            m_dispLabelControl[(int)DispHeader.DepartmentName] = lblLabel04;
+            m_dispLabelControl[(int)DispHeader.ApprovalName] = lblLabel05;
+            m_dispLabelControl[(int)DispHeader.ApprovalStatus] = lblLabel06;
+            m_dispLabelControl[(int)DispHeader.ApprovalDepartmentName] = lblLabel07;
+            m_dispLabelControl[(int)DispHeader.ApprovalDisplayString] = lblLabel08;
+            m_dispLabelControl[(int)DispHeader.PetitionName] = lblLabel09;
+            m_dispLabelControl[(int)DispHeader.PetitionStatus] = lblLabel10;
+            m_dispLabelControl[(int)DispHeader.PetitionHopeDates] = txtHoppesDate;
+            m_dispLabelControl[(int)DispHeader.PetitionDepartmentName] = lblLabel13;
+            m_dispLabelControl[(int)DispHeader.ApprovalProcess] = lblLabel12;
+            m_dispLabelControl[(int)DispHeader.ApprovalDate] = lblLabel14;
+        }
+        #endregion
+
+        #region 画面クリア
+        /// <summary>
+        /// 画面クリア
+        /// </summary>
+        private void ClearDisplay()
+        {
+            foreach (Control wrk in m_dispLabelControl)
+            {
+                if (CommonMotions.chkObjectIsNull(wrk)) continue;
+                wrk.Text = "";
+            }
+
+            dgvEntryData.Rows.Clear();
+            tvDispData.Nodes.Clear();
+        }
+        #endregion
+
+        #region 申請取消しボタンの表示状態を変える
+        /// <summary>
+        /// 申請取消しボタンの表示状態を変える
+        /// </summary>
+        /// <param name="Status"></param>
+        private void DispNotPetitionButton(int Status)
+        {
+            IOPersonApproval pAppDB = new IOPersonApproval();
+            try
+            {
+                // 申請データ取得
+                string strSQL = pAppDB.CreatePrimarykeyString(m_PersonCode, m_ApprovalCode, m_OrderDate, 1);
+                PersonApproval pRec = new PersonApproval();
+                int CurrentPerson = 0;
+                if (pAppDB.SelectAction(strSQL, ref pRec))
+                {
+                    // 申請者を取得する
+                    CurrentPerson = pRec.PersonCode;
+                }
+                else
+                {
+                    // データが無い場合（申請時）はログインユーザー
+                    CurrentPerson = CommonMotions.LoginUserData.PersonCode;
+                }
+
+                // 新セキュリティデータ対応済みかを確認する
+                if (CommonMotions.LoginUserData.SecCode == 0)
+                {
+                    // システム権限によってデータアクセスに制限がある
+                    if (CommonMotions.LoginUserData.SecurityManagement == CommonDefine.AdminSecurityManagement)
+                    {
+                        // システム管理者（すべて対象）
+                    }
+                    else if (CommonMotions.LoginUserData.SecurityManagement == CommonDefine.SystemManageDiv[(int)CommonDefine.SysManaDivNo.PresidentAuthority].Key)
+                    {
+                        // 最高機密管理者（すべて対象）
+                    }
+                    else
+                    {
+                        // ログイン者が申請者か承認時の管理担当者以外は取消しできない
+                        if (pRec.PersonCode != CommonMotions.LoginUserData.PersonCode && CurrentPerson != CommonMotions.LoginUserData.PersonCode) return;
+                    }
+                }
+                else
+                {
+                    // システム権限によってデータアクセスに制限がある
+                    if(CommonMotions.LoginUserData.PersonCode == CommonDefine.AdminCode)
+                    {
+                        // システム管理者（すべて対象）
+                    }
+                    else if (CommonMotions.LoginUserSecurity.SecRank == CommonDefine.SecurityRankList[(int)CommonDefine.SecurityRankPos.SpecialAuthority].Key)
+                    {
+                        // 経営者アクセス
+                    }
+                    else
+                    {
+                        // ログイン者が申請者以外は取消しできない
+                        if (pRec.PersonCode != CommonMotions.LoginUserData.PersonCode) return;
+                    }
+                }
+
+                // 申請・承認以外は申請ボタンを表示する
+                switch (pRec.ApprovalStatus)
+                {
+                    case (int)CommonDefine.ApprovalStatus.Petition:     // 申請
+                    case (int)CommonDefine.ApprovalStatus.Pending:      // 保留
+                    case (int)CommonDefine.ApprovalStatus.Approval:     // 承認
+                    case (int)CommonDefine.ApprovalStatus.NotApproval:  // 不承認
+                        btnNotPetition.Visible = true;                                                                      // 申請取消ボタン
+                        break;
+                    case (int)CommonDefine.ApprovalStatus.Undecided:    // 未定
+                        btnNotPetition.Visible = false;                                                                     // 申請取消ボタン
+                        break;
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                pAppDB.close(); pAppDB = null;
+            }
+
+        }
+        #endregion
+
+        #region 確認画面を使用する
+        /// <summary>
+        /// 確認画面を使用する
+        /// </summary>
+        private void SetConfirmationForm()
+        {
+            // 管理担当部署取得
+            int DepCode = ClsApprovalPermission.GetFromPersonAndApprovalTheDepartment(m_PersonCode, m_ApprovalCode, m_OrderDate);
+            // ログイン者が承認者かどうか確認する
+            if (ClsApprovalPermission.CheckUserForApprover(m_ApprovalCode, DepCode)) return;
+
+            // 承認者以外は確認画面使用のみ
+            panel3.Visible = false;
+            this.Size = new Size(this.Size.Width, (this.Size.Height - panel3.Height));
+            panel5.Size = new Size(panel5.Size.Width, (panel2.Size.Height + panel4.Size.Height));
+            tvDispData.Size = new Size(tvDispData.Size.Width, (panel5.Size.Height - 40));
+
+            btnEnd.Location = new Point(btnEnd.Location.X, (btnEnd.Location.Y - panel3.Height));
+        }
+        #endregion
+
+        #region タイトルとボタンの表示状態を制御する
+        /// <summary>
+        /// タイトルとボタンの表示状態を制御する
+        /// </summary>
+        private void SetDisplayTitleAndButton(int Status)
+        {
+            switch (Status)
+            {
+                case (int)CommonDefine.ApprovalStatus.Petition: // 申請
+                case (int)CommonDefine.ApprovalStatus.Pending:  // 保留
+                case (int)CommonDefine.ApprovalStatus.Approval: // 承認
+                    label1.Text = "担　当　者　承　認　処　理";                                                          // タイトル
+                    btnPetition.Visible = false;                                                                        // 申請ボタン
+                    txtHoppesDate.Enabled = false;                                                                      // 承認希望日
+
+                    btnApproval.Visible = true;                                                                         // 承認ボタン
+                    btnNotApproval.Visible = true;                                                                      // 不承認ボタン
+                    btnOnHold.Visible = true;                                                                           // 保留ボタン
+                    break;
+                case (int)CommonDefine.ApprovalStatus.Undecided:    // 未定
+                case (int)CommonDefine.ApprovalStatus.NotApproval:  // 不承認
+                    label1.Text = "担　当　者　申　請　処　理";                                                          // タイトル
+                    btnPetition.Visible = true;                                                                         // 申請ボタン
+                    txtHoppesDate.Enabled = true;                                                                       // 承認希望日
+
+                    btnApproval.Visible = false;                                                                        // 承認ボタン
+                    btnNotApproval.Visible = false;                                                                     // 不承認ボタン
+                    btnOnHold.Visible = false;                                                                          // 保留ボタン
+                    break;
+            }
+        }
+        #endregion
+
+        #region 承認基本情報取得
+        /// <summary>
+        /// 承認の基本情報
+        /// </summary>
+        /// <returns></returns>
+        private bool SetBaseInfoData()
+        {
+            IOMApproval mAppDB = new IOMApproval();
+            try
+            {
+                // 承認経路マスタ取得
+                string strSQL = string.Format("SELECT * FROM APPROVALMASTER A WHERE A.APPROVALCODE = {0}", m_ApprovalCode);
+                strSQL += " AND A.DEPARTMENTCODE = (SELECT B.DEPARTMENTCODE FROM PERSONINCHARGEMASTER B";
+                strSQL += string.Format(" WHERE B.PERSONCODE = {0})", m_PersonCode);
+                strSQL += " Order By DISPLAYORDER";
+                ArrayList arList = new ArrayList();
+                if (!mAppDB.ExecuteReader(strSQL, ref arList)) return false;
+                foreach (object[] objRec in arList)
+                {
+                    ApprovalMaster work = new ApprovalMaster();
+                    mAppDB.Reader2Struct(objRec, ref work);
+                    m_ApprovalList.Add(work);
+                }
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                mAppDB.close(); mAppDB = null;
+            }
+        }
+        #endregion
+
+        #region ヘッダー情報表示
+        /// <summary>
+        /// ヘッダー情報表示
+        /// </summary>
+        /// <returns></returns>
+        private bool SetHeader()
+        {
+            IOMPersonInCharge PersonDB = new IOMPersonInCharge();
+            try
+            {
+                // 担当者マスタ取得
+                string strSQL = "SELECT A.PERSONCODE, A.PERSONNAME, B.DEPARTMENTCODE, B.DEPARTMENTSTRING";
+                strSQL += " FROM PERSONINCHARGEMASTER A, DEPARTMENTMASTER B";
+                strSQL += string.Format(" WHERE A.PERSONCODE = {0}", m_PersonCode);
+                strSQL += " AND B.DEPARTMENTCODE = A.DEPARTMENTCODE";
+                ArrayList PersonRec = new ArrayList();
+                if (!PersonDB.ExecuteReader(strSQL, ref PersonRec)) return false;
+                
+                // ----- データ表示
+                // 担当者名
+                m_dispLabelControl[(int)DispHeader.PersonName].Text = CommonMotions.cnvString(PersonRec[1]);
+                
+                // 担当者部署
+                m_dispLabelControl[(int)DispHeader.DepartmentName].Text = CommonMotions.cnvString(PersonRec[3]);
+
+                // 承認機能
+                m_dispLabelControl[(int)DispHeader.ApprovalProcess].Text = ClsExcute.AppovalList[m_ApprovalCode];
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                PersonDB.close(); PersonDB = null;
+            }
+        }
+        #endregion
+
+        #region 申請情報表示
+        /// <summary>
+        /// 申請情報表示
+        /// </summary>
+        private void SetPetitionData()
+        {
+            IOPersonApproval pAppDB = new IOPersonApproval();
+            try
+            {
+                string strDate = string.Empty;
+                string strComment = string.Empty;
+                int ApprovalStatus = (int)CommonDefine.ApprovalStatus.Undecided;
+                string strPersonName = string.Empty;
+                string strPersonPosion = string.Empty;
+                string strDepartment = string.Empty;
+                string EntryDate = DateTime.Now.ToShortDateString();
+                // 申請データ取得
+                string strSQL = pAppDB.CreatePrimarykeyString(m_PersonCode, m_ApprovalCode, m_OrderDate, 1);
+                PersonApproval pRec = new PersonApproval();
+                if (!pAppDB.SelectAction(strSQL, ref pRec))
+                {
+                    // データ無は申請無
+                    // ----- データセット
+                    pRec.PersonCode = CommonMotions.LoginUserData.PersonCode;                                                   // 申請者コード
+                    pRec.ApprovalStatus = (int)CommonDefine.ApprovalStatus.Undecided;                                           // 承認状態
+                }
+
+                // 申請者名取得
+                strSQL = "SELECT NVL(C.APPROVALSTATUS, -1),";
+                strSQL += " TO_CHAR(C.APPROVALLIMITDATES,'YYYY/MM/DD'),";
+                strSQL += " C.INPUTCOMMENT,";
+                strSQL += " A.PersonName,";
+                strSQL += " A.DisplayString,";
+                strSQL += " B.DepartmentString,";
+                strSQL += " TO_CHAR(C.ENTRYDATE,'YYYY/MM/DD')";
+                strSQL += " FROM PERSONINCHARGEMASTER A";
+                strSQL += " LEFT JOIN DEPARTMENTMASTER B ON B.DEPARTMENTCODE = A.DEPARTMENTCODE";
+                strSQL += " LEFT JOIN PersonApproval C ON C.PERSONCODE = A.PERSONCODE";
+                strSQL += pAppDB.CreatePrimarykeyString(m_PersonCode, m_ApprovalCode, m_OrderDate, 1, 0, "C.").Replace("Where", "AND");
+                strSQL += string.Format(" WHERE A.PersonCode = {0}", pRec.PersonCode);
+
+                ArrayList pAppRec = new ArrayList();
+                if (!pAppDB.ExecuteReader(strSQL, ref pAppRec)) return;
+
+                object[] objrec = (object[])pAppRec[0];
+                strPersonName = CommonMotions.cnvString(objrec[3]);
+                strPersonPosion = CommonMotions.cnvString(objrec[4]);
+                strDepartment = CommonMotions.cnvString(objrec[5]);
+                if (CommonMotions.cnvInt(objrec[0]) >= 0)
+                {
+                    ApprovalStatus = CommonMotions.cnvInt(objrec[0]);
+                    strDate = CommonMotions.cnvString(objrec[1]);
+                    strComment = CommonMotions.cnvString(objrec[2]);
+                    EntryDate = CommonMotions.cnvString(objrec[6]);
+                }
+
+                m_dispLabelControl[(int)DispHeader.PetitionStatus].Text = CommonDefine.ApprovalStatusString[ApprovalStatus];            // 申請状態
+
+                m_dispLabelControl[(int)DispHeader.PetitionName].Text = strPersonName;                                                  // 申請者名
+                
+                m_dispLabelControl[(int)DispHeader.PetitionHopeDates].Text = strDate;                                                   // 承認希望日
+
+                m_dispLabelControl[(int)DispHeader.PetitionDepartmentName].Text = strDepartment;                                        // 部署名
+
+                m_dispLabelControl[(int)DispHeader.ApprovalDate].Text = EntryDate;                                                      // 登録年月日
+
+
+                // 申請取消ボタン表示(申請時以外は押下可能)
+                DispNotPetitionButton(ApprovalStatus);
+
+                // 申請・承認以外は申請ボタンを表示する
+                SetDisplayTitleAndButton(ApprovalStatus);
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                pAppDB.close(); pAppDB = null;
+            }
+        }
+        #endregion
+
+        #region 承認一覧表示
+        /// <summary>
+        /// 承認一覧表示
+        /// </summary>
+        private bool SetApprovalData()
+        {
+            IOPersonApproval pAppDB = new IOPersonApproval();
+            try
+            {
+                dgvEntryData.Rows.Clear();
+                // スクロールの時は最後のカラムより20ピッチ減らす
+                if (m_ApprovalList.Count > 5)
+                {
+                    dgvEntryData.Columns[(int)DispGridColumn.DisplayString].Width = 140;
+                }
+
+                // 承認データを取得する
+                string strSQL = "SELECT NVL(C.APPROVALSTATUS, -1),";
+                strSQL += " TO_CHAR(C.PETITIONAPPROVALDATE,'YYYY/MM/DD'),";
+                strSQL += " C.INPUTCOMMENT,";
+                strSQL += " A.PersonName,";
+                strSQL += " A.DisplayString,";
+                strSQL += " B.DepartmentString,";
+                strSQL += " D.APPROVALPERSON,";
+                strSQL += " D.DISPLAYORDER";
+                strSQL += " FROM PERSONINCHARGEMASTER A";
+                strSQL += " LEFT JOIN DEPARTMENTMASTER B ON B.DEPARTMENTCODE = A.DEPARTMENTCODE";
+                strSQL += " LEFT JOIN PersonApproval C ON C.PERSONCODE = A.PERSONCODE";
+                strSQL += string.Format(" AND C.CONSTRUCTIONCODE = {0}", m_PersonCode);
+                strSQL += string.Format(" And C.APPROVALCODE = {0}", m_ApprovalCode);
+                strSQL += string.Format(" And C.ORDERNO = {0}", m_OrderDate);
+                strSQL += " AND C.PERSONCODE = A.PERSONCODE";
+                strSQL += " , APPROVALMASTER D";
+                strSQL += " WHERE A.PersonCode IN (";
+
+                bool bFirst = true;
+                foreach (ApprovalMaster rec in m_ApprovalList)
+                {
+                    if (!bFirst) strSQL = " ,";
+                    strSQL += string.Format(" {0}", rec.ApprovalPerson);
+                }
+                strSQL += ")";
+                strSQL += " AND D.DEPARTMENTCODE = A.DEPARTMENTCODE";
+                strSQL += " ORDER BY D.DISPLAYORDER";
+
+                ArrayList pAppRec = new ArrayList();
+                if (!pAppDB.ExecuteReader(strSQL, ref pAppRec)) return false;
+
+                // 状態の取得
+                int ApprovalStatus = 0;
+                string strDate = string.Empty;
+                string strComment = string.Empty;
+                string strPersonName = string.Empty;
+                string strPersonPosion = string.Empty;
+                string strDepartment = string.Empty;
+
+                foreach (object[] objrec in pAppRec)
+                {
+                    ApprovalStatus = (int)CommonDefine.ApprovalStatus.Undecided;
+                    strDate = "未処理";
+                    strComment = string.Empty;
+                    strPersonName = string.Empty;
+                    strPersonPosion = string.Empty;
+                    strDepartment = string.Empty;
+
+                    strPersonName = CommonMotions.cnvString(objrec[3]);
+                    strPersonPosion = CommonMotions.cnvString(objrec[4]);
+                    strDepartment = CommonMotions.cnvString(objrec[5]);
+                    if (CommonMotions.cnvInt(objrec[0]) > -1)
+                    {
+                        ApprovalStatus = CommonMotions.cnvInt(objrec[0]);
+                        strDate = CommonMotions.cnvString(objrec[1]);
+                        strComment = CommonMotions.cnvString(objrec[2]);
+                    }
+
+                    // データ表示
+                    int AddRowCnt = dgvEntryData.Rows.Add(CommonMotions.cnvInt(objrec[6]),
+                                                            CommonMotions.cnvInt(objrec[7]),
+                                                            strPersonName,
+                                                            CommonDefine.ApprovalStatusString[ApprovalStatus],
+                                                            strDate,
+                                                            strDepartment,
+                                                            strPersonPosion);
+                    dgvEntryData.Rows[AddRowCnt].Cells[(int)DispGridColumn.ApprovalStatus].Style.BackColor = CommonDefine.ApprovalBackColorStatusColor[ApprovalStatus];
+                    dgvEntryData.Rows[AddRowCnt].Cells[(int)DispGridColumn.ApprovalStatus].Style.ForeColor = CommonDefine.ApprovalForeColorStatusColor[ApprovalStatus];
+                }
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                pAppDB.close(); pAppDB = null;
+
+                // 5行表示なので足りない場合は空行で埋める
+                if ((5 - dgvEntryData.RowCount) > 0) dgvEntryData.Rows.Add((5 - dgvEntryData.RowCount));
+            }
+        }
+        #endregion
+
+        #region 承認情報表示
+        /// <summary>
+        /// 承認情報表示
+        /// </summary>
+        /// <returns></returns>
+        private bool SetCurrentApproval()
+        {
+
+            IOMDepartment dpDB = new IOMDepartment();
+            IOPersonApproval pAppDB = new IOPersonApproval();
+            try
+            {
+                // 自分は承認者一覧にあるか？
+                bool bExeist = false;
+                foreach (DataGridViewRow rowData in dgvEntryData.Rows)
+                {
+                    // 空白は次へ
+                    if (CommonMotions.chkCellBlank(rowData.Cells[(int)DispGridColumn.ApprovalCode].Value)) continue;
+                    // 自分と一緒か？
+                    int iCode = CommonMotions.cnvInt(rowData.Cells[(int)DispGridColumn.ApprovalCode].Value);
+                    if (iCode == CommonMotions.LoginUserData.PersonCode)
+                    {
+                        bExeist = true;
+                        break;
+                    }
+                }
+                // 承認者でない場合は抜ける
+                if (!bExeist) return true;
+
+                // 承認者情報
+                // 部署名取得
+                DepartmentMaster DepartmentRec = new DepartmentMaster();
+                string strDepartment = dpDB.CreatePrimarykeyString(CommonMotions.LoginUserData.DepartmentCode);
+                dpDB.SelectAction(strDepartment, ref DepartmentRec);
+
+                string strStatus = "未　定";
+                string strComment = string.Empty;
+
+                string strSQL = pAppDB.CreatePrimarykeyString(m_PersonCode, m_ApprovalCode, m_OrderDate);
+                strSQL += string.Format(" And SeqNo != 1 And PersonCode = {0}", CommonMotions.LoginUserData.PersonCode);
+                PersonApproval pAppRec = new PersonApproval();
+                if (pAppDB.SelectAction(strSQL, ref pAppRec))
+                {
+                    strStatus = CommonDefine.ApprovalStatusString[pAppRec.ApprovalStatus];
+                }
+
+                m_dispLabelControl[(int)DispHeader.ApprovalName].Text = CommonMotions.LoginUserData.PersonName;                     // 承認者名
+                m_dispLabelControl[(int)DispHeader.ApprovalDepartmentName].Text = DepartmentRec.DepartmentString;                   // 部署名
+                m_dispLabelControl[(int)DispHeader.ApprovalDisplayString].Text = CommonMotions.LoginUserData.DisplayString;         // 役職名
+                m_dispLabelControl[(int)DispHeader.ApprovalStatus].Text = strStatus;                                                // 状態
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                pAppDB.close(); pAppDB = null;
+                dpDB.close(); dpDB = null;
+            }
+        }
+        #endregion
+
+        #region 画面データチェック
+        /// <summary>
+        /// 画面項目のチェック
+        /// </summary>
+        /// <returns></returns>
+        private bool DispFeildCheck()
+        {
+            bool bAns = true;
+            bool bRet = true;
+            try
+            {
+                // 希望承認日
+                bAns = CommonMotions.DispFieldDateCheck(m_dispLabelControl[(int)DispHeader.PetitionHopeDates], true);
+                bRet &= bAns;
+
+                if (!bRet)
+                {
+                    MessageBox.Show("入力値にエラーがあります、確認してください。", "データ確認", MessageBoxButtons.OK, MessageBoxIcon.Warning);
+                    return false;
+                }
+
+                return bRet;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+
+        #endregion
+
+        // ----- 指示連絡コメント処理　↓↓
+        #region 指示連絡コメント表示処理
+        /// <summary>
+        /// 指示連絡コメント表示処理
+        /// </summary>
+        private void DispTreeViewComment()
+        {
+            IOPersonApprovalCommnet CommentDB = new IOPersonApprovalCommnet();
+            try
+            {
+                tvDispData.Nodes.Clear();
+
+                string strSQL = CommentDB.CreatePrimarykeyString(m_PersonCode, m_ApprovalCode, m_OrderDate);
+                List<PersonApprovalCommnet> CommentList = new List<PersonApprovalCommnet>();
+                if (!CommentDB.SelectAction(strSQL, ref CommentList)) return;
+
+                TreeNode treeNode = null;
+                for (int i = 0; i < CommentList.Count; i++)
+                {
+                    treeNode = tvDispData.Nodes.Add(CommentList[i].ApproValComment);
+                    if (CommentList[(i + 1)].ParentNo > 0)
+                    {
+                        GetDataListRecursive(treeNode, CommentList, ref i);
+                    }
+                    treeNode.Expand();
+                }
+                tvDispData.TopNode.Expand();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                CommentDB.close(); CommentDB = null;
+            }
+        }
+        #endregion
+
+        #region 下位ノード表示処理
+        /// <summary>
+        /// 下位ノード表示処理
+        /// </summary>
+        private void GetDataListRecursive(TreeNode treeNode, List<PersonApprovalCommnet> DataList, ref int DataIndex)
+        {
+            try
+            {
+                int ParentCnt = DataIndex;
+                // コメントデータセット
+                TreeNode tn = null;
+
+                // Get each node recursively.
+                for (++DataIndex; DataIndex < DataList.Count; DataIndex++)
+                {
+                    if (DataList[DataIndex].ParentNo == DataList[ParentCnt].CommentNo)
+                    {
+                        tn = treeNode.Nodes.Add(DataList[DataIndex].ApproValComment);
+                    }
+                    else if (DataList[DataIndex].ParentNo < DataList[ParentCnt].CommentNo)
+                    {
+                        --DataIndex;    // 次の処理で加算するための減算
+                        break;
+                    }
+                    else if (DataList[DataIndex].ParentNo > DataList[ParentCnt].CommentNo)
+                    {
+                        --DataIndex;    // 次の処理で加算するための減算
+                        GetDataListRecursive(tn, DataList, ref DataIndex);
+                    }
+                    tn.Expand();
+                }
+                treeNode.Expand();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 指示連絡コメント作成処理
+        /// <summary>
+        /// 指示連絡コメント作成処理
+        /// </summary>
+        private void CreateTreeViewComment(bool bNewComment = true)
+        {
+            FrmInputComment frm = new FrmInputComment();
+            try
+            {
+                TreeNode TargetNodes = tvDispData.SelectedNode;
+                if (!bNewComment)
+                {
+                    if (TargetNodes == null)
+                    {
+                        MessageBox.Show("返信対象コメントが選択されていません。", "選択エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return;
+                    }
+                }
+
+                // コメント入力画面表示
+                frm.ShowDialog();
+                if (frm.EndButton == DialogResult.No) return;
+
+                string DispString = string.Empty;
+                DispString = string.Format("{0}月{1}日－{2}－{3}", DateTime.Today.Month.ToString("00"),
+                                                                    DateTime.Today.Day.ToString("00"),
+                                                                    CommonMotions.LoginUserData.PersonName,
+                                                                    frm.CommentString);
+                // コメント追加
+                if (bNewComment)
+                {
+                    tvDispData.Nodes.Add(DispString);
+                    tvDispData.TopNode.Expand();
+                }
+                else
+                {
+                    TargetNodes.Nodes.Add(DispString);
+                    tvDispData.SelectedNode.Expand();
+                }
+                // データ登録
+                EntryComment();
+
+                // 完了メッセージ
+                CommonMotions.EntryEndMessage("コメントデータ");
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                frm.Dispose(); frm = null;
+            }
+        }
+        #endregion
+
+        #region 指示連絡コメント削除処理
+        /// <summary>
+        /// 指示連絡コメント削除処理
+        /// </summary>
+        private void RemoveTreeViewComment()
+        {
+            try
+            {
+                TreeNode TargetNodes = null;
+                TargetNodes = tvDispData.SelectedNode;
+                if (TargetNodes == null)
+                {
+                    MessageBox.Show("削除対象コメントが選択されていません。", "選択エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return;
+                }
+                if (MessageBox.Show("対象のコメントを削除します。\nよろしいでしょうか？",
+                                    "削除確認",
+                                    MessageBoxButtons.OKCancel,
+                                    MessageBoxIcon.Information) == DialogResult.Cancel) return;
+
+                // 削除
+                TargetNodes.Remove();
+            
+                // データ登録
+                EntryComment();
+
+                // 完了メッセージ
+                CommonMotions.RemoveEndMessage("コメントデータ");
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 登録時情報
+        /// <summary>
+        /// 登録時SQL文字列
+        /// </summary>
+        private string m_InsertSQL = string.Empty;
+        /// <summary>
+        /// 登録時コメント番号
+        /// </summary>
+        private int m_InsertNo = 0;
+        /// <summary>
+        /// 登録時親コメント番号
+        /// </summary>
+        private int m_InsertParentNo = 0;
+        #endregion
+
+        #region コメントデータ一括削除
+        /// <summary>
+        /// コメントデータ一括削除
+        /// </summary>
+        /// <param name="CommentDB"></param>
+        private void RemoveCommentData()
+        {
+            IOPersonApprovalCommnet CommentDB = new IOPersonApprovalCommnet();
+            try
+            {
+                // 削除
+                string strSQL = CommentDB.CreatePrimarykeyString(m_PersonCode, m_ApprovalCode, m_OrderDate);
+                CommentDB.DeleteAction(strSQL);
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                CommentDB.close(); CommentDB = null;
+            }
+        }
+        #endregion
+
+        #region コメントデータ登録
+        /// <summary>
+        /// コメントデータ登録
+        /// </summary>
+        private void EntryComment()
+        {
+            IOPersonApprovalCommnet CommentDB = new IOPersonApprovalCommnet();
+            try
+            {
+                CommentDB.connect(); CommentDB.beginTran();
+                // まず削除
+                string strSQL = CommentDB.CreatePrimarykeyString(m_PersonCode, m_ApprovalCode, m_OrderDate);
+                CommentDB.DeleteAction(strSQL, false);
+
+                // ノードが無い場合は以下を処理しない
+                if (tvDispData.GetNodeCount(true) == 0) return;
+                
+                m_InsertNo = 1;
+                m_InsertParentNo = 0;
+                m_InsertSQL = "INSERT ALL";
+                foreach (TreeNode n in tvDispData.Nodes)
+                {
+                    m_InsertParentNo = 0;
+                    GetNodesRecursive(n);
+                }
+                m_InsertSQL += " SELECT * FROM DUAL";
+                if (!CommentDB.ExecuteNonQuery(m_InsertSQL, false))
+                {
+                    MessageBox.Show("承認申請コメント登録に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    CommentDB.rollback();
+                }
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                CommentDB.commit();
+                CommentDB.close(); CommentDB = null;
+            }
+        }
+        #endregion
+
+        #region ツリービューのノードを再帰的に取得する
+        /// <summary>
+        /// ツリービューのノードを再帰的に取得する
+        /// </summary>
+        /// <param name="treeNode"></param>
+        private void GetNodesRecursive(TreeNode treeNode)
+        {
+            try
+            {
+                // 親番号退避
+                int localParent = m_InsertNo;
+                // コメントデータセット
+                CreateInsertSQL(treeNode.Text);
+
+                // Get each node recursively.
+                foreach (TreeNode tn in treeNode.Nodes)
+                {
+                    // 親コメント番号セット
+                    m_InsertParentNo = localParent;
+
+                    GetNodesRecursive(tn);
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 登録用INSERT文を作成する
+        /// <summary>
+        /// 登録用INSERT文を作成する
+        /// </summary>
+        /// <param name="strComment"></param>
+        private void CreateInsertSQL(string strComment)
+        {
+            try
+            {
+                m_InsertSQL += " INTO PersonApprovalCommnet";
+
+                m_InsertSQL += " (";
+                bool bFirst = true;
+                foreach (var gender in Enum.GetValues(typeof(IOPersonApprovalCommnet.ColumnName)))
+                {
+                    if (!bFirst) m_InsertSQL += " ,";
+                    m_InsertSQL += gender.ToString();
+                    bFirst = false;
+                }
+                m_InsertSQL += ") VALUES (";
+
+                // 担当者番号
+                m_InsertSQL += string.Format("{0}", m_PersonCode);
+                // 承認機能番号
+                m_InsertSQL += string.Format(",{0}", m_ApprovalCode);
+                // 受付日
+                m_InsertSQL += string.Format(",TO_DATE('{0}','YYYY/MM/DD')", m_OrderDate);
+                // 受付番号
+                m_InsertSQL += string.Format(",{0}", m_OrderNo);
+
+                // コメント番号
+                m_InsertSQL += string.Format(",{0}", m_InsertNo++);
+                // 親コメント番号
+                m_InsertSQL += string.Format(",{0}", m_InsertParentNo);
+                // 指示・連絡コメント
+                m_InsertSQL += string.Format(",'{0}'", strComment);
+
+                // 登録年月日
+                m_InsertSQL += ", TO_DATE(TO_CHAR(sysdate,'YYYY/MM/DD HH24:MI:SS'),'YYYY/MM/DD HH24:MI:SS')";
+                // 更新年月日
+                m_InsertSQL += ", TO_DATE(TO_CHAR(sysdate,'YYYY/MM/DD HH24:MI:SS'),'YYYY/MM/DD HH24:MI:SS')";
+
+                m_InsertSQL += ")";
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+        // ----- 指示連絡コメント処理　↑↑
+    }
+}
